import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class DKA extends Frame
{  public int Iter; public double Err; boolean DKA;
   public DKA()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [] setData()
   {  double [] A = { 1, -9, -7, -35, 50}; // X^4-9X^3-7X^2-35X+50
      return A;
   }
   public double [] InitFactor(double[] A, int N)
   {  double [] B = new double[N+1];
      B[0] = A[0]; for(int j=1; j <= N;j++) B[j] = A[j] / A[0];
      return B;
   }
   public double Radius(double[] A, int N)
   {  double R0 = 0; 
      for(int j = 2; j<=N; j++)
      {  double Rn = N * Math.pow(Math.abs(A[j]), 1.0 / ((double)j));
         if(Rn > R0) R0 = Rn;
      }
      return R0;
   }
   public Complex [] InitialSet(double R0, int N)
   {  Complex [] X = new Complex [N];
      double Pi = 3.1415926535897932385;
      for(int j = 0; j<N; j++)
      {  double Th = 2.0 * Pi * (double) j / (double) N + Pi / (2.0 * (double)N);
         X[j] = new Complex(R0 * Math.cos(Th), R0 * Math.sin(Th));
      }
      return X;
   }
   public Complex[] solution(double []A, int N, double delta)
   {
     DKA = false; int IterMax=500;
     Complex Xkj, Fx, beforX, Adj; 
     double  []B  = InitFactor(A, N);
     Complex []X = InitialSet(Radius(A,N),N);
     for(int i=0; i <= IterMax; i++)
     {  double MaxError = 0;
        for(int j = 0; j < N; j++)
        {  Xkj = new Complex(1, 0); Fx = new Complex(1, 0); beforX = X[j];
           for(int k = 0; k < N; k++)
           {   Fx = (Fx.mult(beforX)).add(A[k + 1]);
               if(k != j) Xkj = Xkj.mult(beforX.sub(X[k]));
           }
           Adj = Fx.div(Xkj); X[j] = beforX.sub(Adj);
           Err = Fx.abs(); if(Err > MaxError) MaxError = Err;
         }
         if(MaxError < delta){ Iter=i;  return X;}
     }
     DKA = true; Iter = IterMax;
     return X;
   }
   public void paint(Graphics g)
   {  setTitle("fj[gEv\@");
      Complex[] R = solution(setData(), 4, 0.0001);
      if(DKA) g.drawString( "ʂ܂ł" ,20,50);
      g.drawString( "  (JԂ = "+ Iter + ", 덷 = " + Err +")" ,20,80);
      for(int i = 0; i < 4; i++)  g.drawString( " " + i + " : " + R[i] .ToString() ,20, 100 + i*20);
   } 
   public static void main(String[] args)
   {  Frame w = new DKA();
      w.setVisible(true);
   }
}
